<!-- 选择系统管理中的文件模板管理 -->
<script lang="ts" setup name="SelectFileTemplateDialog">
import { ElMessage } from 'element-plus'
import type { Ref } from 'vue'
import { ref } from 'vue'
import dayjs from 'dayjs'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { templatePage } from '@/api/system/tool'
import { getDictByCode } from '@/api/system/dict'
const emits = defineEmits(['confirm'])
const dialogFormVisible = ref(false)
// 查询条件
const listQuery = ref({
  templateNo: '', // 编号
  templateName: '', // 名称
  templateCreator: '', // 负责人
  createStartTime: '',
  createEndTime: '',
  limit: 5,
  offset: 1,
  templateType: '',
  ids: [] as string[],
})
// 多选选中的内容
const checkoutList = ref([])
const loadingTable = ref(false)
const list = ref([]) // 表格数据
const total = ref(0)
const columns = ref<TableColumn[]>([
  { text: '编号', value: 'templateNo', align: 'center', width: '160' },
  { text: '模板名称', value: 'templateName', align: 'center' },
  { text: '模板类型', value: 'templateTypeName', align: 'center' },
  { text: '模板负责人', value: 'templateCreator', align: 'center' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '180' },
  { text: '描述', value: 'templateDesc', align: 'center' },
])
const createTime = ref()
// 获取类型
const templateTypeMap = ref({}) as any // 模板类型{1: 新建}
const getType = async () => {
  loadingTable.value = true
  const res = await getDictByCode('templateType')
  res.data.forEach((item: any) => {
    templateTypeMap.value[`${item.value}`] = item.name
  })
}
// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  templatePage(listQuery.value).then((res) => {
    if (res.code === 200) {
      list.value = res.data.rows.map((item: { templateType: string }) => {
        return {
          ...item,
          templateTypeName: item.templateType ? templateTypeMap.value[item.templateType] : item.templateType, // 模板类型
        }
      })
      total.value = res.data.total
    }
    loadingTable.value = false
  }).catch((_) => {
    loadingTable.value = false
  })
}
// 重置
const reset = () => {
  listQuery.value = {
    templateNo: '', // 编号
    templateName: '', // 名称
    templateCreator: '', // 负责人
    createStartTime: '',
    createEndTime: '',
    limit: 20,
    offset: 1,
    templateType: '',
    ids: [] as string[],
  }
  fetchData()
}
// 搜索
const search = () => {
  fetchData(true)
}
// 多选选中
const handleSelectionChange = (val: any) => {
  checkoutList.value = val
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number;page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  search()
}
// 点击确定
const confirmSelect = () => {
  if (!checkoutList.value.length) {
    ElMessage.warning('请选择标准文档模板')
  }
  else {
    emits('confirm', checkoutList.value)
    dialogFormVisible.value = false
  }
}
// 取消
const resetForm = () => {
  dialogFormVisible.value = false
  reset()
}
// 初始化
const initDialog = () => {
  getType().then((_) => {
    fetchData()
  })
  dialogFormVisible.value = true
}

watch(() => createTime.value, (newVal) => {
  if (newVal) {
    listQuery.value.createStartTime = newVal[0]
    listQuery.value.createEndTime = newVal[1]
  }
  else {
    listQuery.value.createStartTime = ''
    listQuery.value.createEndTime = ''
  }
})

defineExpose({ initDialog })
</script>

<template>
  <el-dialog v-if="dialogFormVisible" v-model="dialogFormVisible" title="选择标准文档模板" width="65%">
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <search-item>
        <el-input v-model="listQuery.templateNo" placeholder="编号" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-input v-model="listQuery.templateName" placeholder="模板名称" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-input v-model="listQuery.templateCreator" placeholder="模板负责人" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="createTime"
          type="datetimerange"
          format="YYYY-MM-DD HH:mm:ss" value-format="YYYY-MM-DD HH:mm:ss"
          range-separator="至"
          start-placeholder="创建开始时间"
          end-placeholder="创建结束时间"
          clearable
        />
      </search-item>
    </search-area>

    <!-- 查询结果Table显示 -->
    <div style="padding: 12px;">
      <normal-table
        :data="list"
        :total="total"
        :columns="columns"
        :query="listQuery"
        is-showmulti-select
        :list-loading="loadingTable"
        :is-multi="false"
        :height="260"
        :page-sizes="[5]"
        @change="changePage"
        @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="confirmSelect">确认</el-button>
        <el-button @click="resetForm">
          取消
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
:deep(.el-radio__label) {
  display: none;
}
</style>
